/** @file counter_coverage.h
 * This file contains coverage class description.
 *
 * @author Mikhail Chupilko (chupilko@ispras.ru)
 */

#pragma once

#include <hw/model.hpp>
#include <ts/coverage.hpp>
#include <tracer/tracer.hpp>

namespace cpptesk {
namespace examples {
namespace counter {

class Counter;

class CounterCoverage {
public:
    CounterCoverage(Counter &counter): counter(counter) {}

    cpptesk::tracer::coverage::CoverageTracker coverageTracker;

    DEFINE_ENUMERATED_COVERAGE(Counter_BitSet, "iface1 ready", (
                               (I0, "yes"),
                               (I1, "no")
            ));

    Counter_BitSet cov_BitSet(void) const;

    void out_cov(void);

protected:
    Counter &counter;
};

}}}
