/** @file counter_msg.cpp
 * This file contains implementation of message classes.
 *
 * @author Mikhail Chupilko (chupilko@ispras.ru)
 */

#include <counter_msg.h>

namespace cpptesk {
namespace examples {
namespace counter {

InputData::InputData(void)
{
    ADD_FIELD(InputData::id);
    ADD_FIELD(InputData::timemark);
}

InputData::InputData(int id, int timemark)
{
    ADD_FIELD(InputData::id);
    ADD_FIELD(InputData::timemark);
    set_id(id);
    set_timemark(timemark);
}

InputData::~InputData(void) {}

OutputData::OutputData(void)
{
    ADD_FIELD(OutputData::data);
    ADD_INCOMPARABLE_FIELD(OutputData::id);
    ADD_INCOMPARABLE_FIELD(OutputData::timemark);
}

OutputData::OutputData(uint8_t data)
{
    ADD_FIELD(OutputData::data);
    set_data(data);
}

OutputData::OutputData(int id, int timemark)
{
    ADD_FIELD(OutputData::data);
    ADD_INCOMPARABLE_FIELD(OutputData::id);
    ADD_INCOMPARABLE_FIELD(OutputData::timemark);
    set_id(id);
    set_timemark(timemark);
}

OutputData::~OutputData(void) {}

}}}
