/*
 * Copyright 2009 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/*
 * File: aspect_coverage.h
 * Description:
 *       This file contains interface definition of Aspectrace aspect "coverage".
 */

#ifndef __ASPECT_COVERAGE_H
#define __ASPECT_COVERAGE_H

/* Ctesk coverages */
#include <ts/coverage.h>

typedef struct aspect_coverage_element aspect_coverage_element;

aspect_coverage_element *create_CoverageElement(const char *name, aspect_coverage_element **child, size_t count);
// aspect_coverage_element *create_CoverageElement_a(const char *name, aspect_coverage_element **child);

void aspect_coverage_traceCoverageStructure(const char *aspect, const char *name, aspect_coverage_element **elems, size_t count);
// void aspect_coverage_traceCoverageStructure_a(const char *aspect, const char *name, aspect_coverage_element **elems);

void aspect_coverage_traceCteskCS(CoverageDesc *cs);
#define DECLARE_COVERAGE(name)	extern CoverageDesc _cov_desc_ ## name
#define TRACE_COVERAGE(name)	aspect_coverage_traceCteskCS( &_cov_desc_ ## name )

void aspect_coverage_traceCoverageElement(const char *aspect, const char *structName, const char **elems, size_t count);
// void aspect_coverage_traceCoverageElement_a(const char *aspect, const char *structName, const char **elems);

#endif /* __ASPECT_COVERAGE_H */
